<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleOptimizeMass.py</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleOptimizeMass_8py-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleOptimizeMass.py</div>  </div>
</div><!--header-->
<div class="contents">
<p>A simple parameter optimization example.</p>
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"># OpenSim Moco: exampleOptimizeMass.py                                       #</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"># Copyright (c) 2019 Stanford University and the Authors                     #</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"># Author(s): Noah Gordon, Jennifer Yong                                      #</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"># Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    #</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"># not use this file except in compliance with the License. You may obtain a  #</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"># copy of the License at http://www.apache.org/licenses/LICENSE-2.0          #</span></div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">#                                                                            #</span></div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"># Unless required by applicable law or agreed to in writing, software        #</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"># distributed under the License is distributed on an &quot;AS IS&quot; BASIS,          #</span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"># WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   #</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"># See the License for the specific language governing permissions and        #</span></div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"># limitations under the License.                                             #</span></div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"># -------------------------------------------------------------------------- #</span></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"># Optimize the mass of a simple harmonic oscillator such that it follows the </span></div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"># correct trajectory specified by the state bounds and the MocoMarkerFinalGoal.</span></div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword">import</span> os</div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">import</span> opensim <span class="keyword">as</span> osim</div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="keyword">import</span> numpy <span class="keyword">as</span> np</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="comment"># Setting variables</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;stiffness = 100.</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;mass = 5.</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;finalTime = np.pi * np.sqrt(mass / stiffness)</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment"># Defining the model</span></div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;model = osim.Model()</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;model.setName(<span class="stringliteral">&#39;oscillator&#39;</span>)</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;model.set_gravity(osim.Vec3(0, 0, 0))</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;body = osim.Body(<span class="stringliteral">&#39;body&#39;</span>, np.multiply(0.5, mass), osim.Vec3(0), osim.Inertia(0))</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;model.addComponent(body)</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160; </div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;<span class="comment"># Adding a marker to body in the model</span></div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;marker = osim.Marker(<span class="stringliteral">&#39;marker&#39;</span>, body, osim.Vec3(0))</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;model.addMarker(marker)</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160; </div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment"># Allows translation along x.</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;joint = osim.SliderJoint(<span class="stringliteral">&#39;slider&#39;</span>, model.getGround(), body)</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;coord = joint.updCoordinate()</div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;coord.setName(<span class="stringliteral">&#39;position&#39;</span>)</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;model.addComponent(joint)</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160; </div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;<span class="comment"># Adds the spring component</span></div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;spring = osim.SpringGeneralizedForce()</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;spring.set_coordinate(<span class="stringliteral">&#39;position&#39;</span>)</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;spring.setRestLength(0.)</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;spring.setStiffness(stiffness)</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;spring.setViscosity(0.)</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;model.addComponent(spring)</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="comment"># Create MocoStudy.</span></div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="comment"># ================</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;moco = osim.MocoStudy()</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;moco.setName(<span class="stringliteral">&#39;oscillator_spring_stiffness&#39;</span>)</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160; </div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160; </div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;<span class="comment"># Define the optimal control problem.</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="comment"># ===================================</span></div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;problem = moco.updProblem()</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160; </div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;<span class="comment"># Model (dynamics).</span></div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;<span class="comment"># -----------------</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;problem.setModel(model)</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160; </div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;<span class="comment"># Bounds.</span></div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;<span class="comment"># -------</span></div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;<span class="comment"># Initial time must be 0, final time is finalTime.</span></div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;problem.setTimeBounds(osim.MocoInitialBounds(0.),</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;                      osim.MocoFinalBounds(finalTime))</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160; </div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="comment"># Position must be within [-5, 5] throughout the motion.</span></div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="comment"># Initial position must be -0.5, final position must be within [0.25, 0.75].</span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;problem.setStateInfo(<span class="stringliteral">&#39;/slider/position/value&#39;</span>, osim.MocoBounds(-5., 5.),</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;                     osim.MocoInitialBounds(-0.5),</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;                     osim.MocoFinalBounds(0.25, 0.75))</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160; </div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;<span class="comment"># Speed must be within [-20, 20] throughout the motion.</span></div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="comment"># Initial and final speed must be 0. Use compact syntax.</span></div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;problem.setStateInfo(<span class="stringliteral">&#39;/slider/position/speed&#39;</span>, [-20, 20], [0], [0])</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160; </div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;<span class="comment"># Add Parameter. The default initial guess for a parameter is the midpoint of</span></div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;<span class="comment"># its bounds, *not* the value of a property in the model.</span></div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;problem.addParameter(osim.MocoParameter(<span class="stringliteral">&#39;oscillator_mass&#39;</span>, <span class="stringliteral">&#39;body&#39;</span>, <span class="stringliteral">&#39;mass&#39;</span>,</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;                                        osim.MocoBounds(0, 10)))</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160; </div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;<span class="comment"># Cost.</span></div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;<span class="comment"># -----</span></div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;endpointCost = osim.MocoMarkerFinalGoal()</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;endpointCost.setPointName(<span class="stringliteral">&#39;/markerset/marker&#39;</span>)</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;endpointCost.setReferenceLocation(osim.Vec3(0.5, 0, 0))</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;problem.addGoal(endpointCost)</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160; </div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160; </div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;<span class="comment"># Configure the solver.</span></div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;<span class="comment"># =====================</span></div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;solver = moco.initTropterSolver()</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160; </div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="comment"># Now that we&#39;ve finished setting up the study, print it to a file.</span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;moco.printToXML(<span class="stringliteral">&#39;optimize_mass.omoco&#39;</span>)</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160; </div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="comment"># Solve the problem.</span></div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="comment"># ==================</span></div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;solution = moco.solve()</div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;solution.write(<span class="stringliteral">&#39;optimize_mass_solution.sto&#39;</span>)</div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:01 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
